﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.Data.OleDb;


namespace Conditional_Cell_Formatting
{
    public partial class Form1 : Form
    {

        DataSet nwindDataSet;
        OleDbConnection conn;
        OleDbDataAdapter dataAdapter;
                
        List<Point> modifiedList = new List<Point>();
        
        public Form1()
        {
            InitializeComponent();

            conn = new OleDbConnection("Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" + 
                                        Environment.GetFolderPath(Environment.SpecialFolder.Personal) +
                                        "\\ComponentOne Samples\\Common\\C1Nwind.mdb");

            dataAdapter = new OleDbDataAdapter("Select * from Customers", conn);
            nwindDataSet = new DataSet();
            dataAdapter.Fill(nwindDataSet, "Customers");

            c1TrueDBGrid1.DataSource = nwindDataSet;
            c1TrueDBGrid1.DataMember = "Customers";

            c1TrueDBGrid1.OwnerDrawCell += new C1.Win.C1TrueDBGrid.OwnerDrawCellEventHandler(c1TrueDBGrid1_OwnerDrawCell);
            c1TrueDBGrid1.AfterColEdit += new C1.Win.C1TrueDBGrid.ColEventHandler(c1TrueDBGrid1_AfterColEdit);
            
            //Enable OwnerDraw property for each column
            foreach (C1.Win.C1TrueDBGrid.C1DisplayColumn cd in c1TrueDBGrid1.Splits[0].DisplayColumns)
                cd.OwnerDraw = true;   
        }

        void c1TrueDBGrid1_AfterColEdit(object sender, C1.Win.C1TrueDBGrid.ColEventArgs e)
        {
            //Add the cell details in the list of Modified cells
            int row = c1TrueDBGrid1.Row;
            int col = c1TrueDBGrid1.Splits[0].DisplayColumns.IndexOf(e.Column);
            modifiedList.Add(new Point(row, col));            
        }

        void c1TrueDBGrid1_OwnerDrawCell(object sender, C1.Win.C1TrueDBGrid.OwnerDrawCellEventArgs e)
        {            
            // While repainting each cell, verify if it has been marked as 
            // modified cell (if present in the list of modified cells)
            Point mc = new Point(e.Row, e.Col);
            if (modifiedList.Contains(mc))
                e.Style.BackColor = Color.Red;            
        }

        private void clrButton_Click(object sender, EventArgs e)        
        {
            modifiedList.Clear();
            c1TrueDBGrid1.ClearCellStyle(C1.Win.C1TrueDBGrid.CellStyleFlag.AllCells);                       
        }
      
    }
}
